local M = {}
local auto_pilot = 0
local auto_pilot_mode = 1
local first_yaw = 1
local first_time = 1
local first_z = 1
local first_speed = 1
local OnGround = 1
local landed = 0
local current_yaw = 0
local speed_controller = 1
local lowSpeedWarning = nil
local fallingWarning = nil
local autopilot_selected = nil
local function onInit()
	lowSpeedWarning = lowSpeedWarning or sounds.createSoundscapeSound("lowSpeedWarning")
	fallingWarning = fallingWarning or sounds.createSoundscapeSound("fallingWarning")
	autopilot_selected = autopilot_selected or sounds.createSoundscapeSound("autopilot_selected")
end
local function updateGFX(dt)
if autopilot_selected ~= nil then
M.pos = vec3(obj:getPosition())
M.roll, M.pitch, M.yaw = obj:getRollPitchYaw()
if toggle_auto_pilot == 1 then
	change_to_default = 1
	if auto_pilot == 1 then
	auto_pilot = 0
	gui.message("Autopilot system deactivated.")
	elseif auto_pilot == 0 then
		auto_pilot = 1
		if auto_pilot_mode == 1 then gui.message("Autopilot system activated. Mode: Maintain heading")
		elseif auto_pilot_mode == 4 then gui.message("Autopilot system activated. Mode: Take Off")
		elseif auto_pilot_mode == 2 then gui.message("Autopilot system activated. Mode: Maintain heading and speed")
		elseif auto_pilot_mode == 3 then gui.message("Autopilot system activated. Mode: Maintain speed")
		elseif auto_pilot_mode == 5 then gui.message("Autopilot system activated. Mode: Landing")
		end
	end
	toggle_auto_pilot = 0
end
if auto_pilot == 1 then
	if fallingWarning ~= nil then if M.pitch <= -0.5 then gui.message("Plane is falling!") obj:setVolume(fallingWarning, 10) obj:playSFX(fallingWarning) elseif M.pitch > -0.35 then obj:setVolume(fallingWarning, 0) obj:cutSFX(fallingWarning) end end
	if toggle_auto_pilot_mode == 1 then
		auto_pilot_mode = auto_pilot_mode+1
		change_to_default = 1
		if auto_pilot_mode > 3 then auto_pilot_mode = 1 end
		if auto_pilot_mode == 1 then gui.message("Autopilot Mode: Maintain heading")
		elseif auto_pilot_mode == 2 then gui.message("Autopilot Mode: Maintain heading and speed")
		elseif auto_pilot_mode == 3 then gui.message("Autopilot Mode: Maintain speed")
		end
		toggle_auto_pilot_mode = 0
	end
	if jump_to_mode1 == 1 then
		auto_pilot_mode = 1
		gui.message("Autopilot Mode: Maintain heading")
		jump_to_mode1 = 0
	elseif jump_to_mode2 == 1 then
		auto_pilot_mode = 2
		gui.message("Autopilot Mode: Maintain heading and speed")
		jump_to_mode2 = 0
	elseif jump_to_mode3 == 1 then
		auto_pilot_mode = 3
		gui.message("Autopilot Mode: Maintain speed")
		jump_to_mode3 = 0
	elseif jump_to_mode4 == 1 then
		auto_pilot_mode = 4
		gui.message("Autopilot Mode: Take Off")
		jump_to_mode4 = 0
	elseif jump_to_mode5 == 1 then
		auto_pilot_mode = 5
		gui.message("Autopilot Mode: Landing")
		jump_to_mode5 = 0
	end
if auto_pilot_mode == 1 then
	if electrics.values.airspeed < 55 and electrics.values.airspeed > 18 and lowSpeedWarning ~= nil and electrics.values.gear == 1 then gui.message("You're going too slow, increase the speed!") obj:setVolume(lowSpeedWarning, 7) obj:playSFX(lowSpeedWarning) elseif lowSpeedWarning ~= nil then obj:setVolume(lowSpeedWarning, 0) obj:cutSFX(lowSpeedWarning) end
	first_z = 1
	first_speed = 1
	speed_controller = 1
	first_yaw = 1
	landed = 0
	OnGround = 1
	if first_time == 1 then
		input.event('aileron', 0)
		input.event('elevator', 0)
		input.event('rudder', 0)
		electrics.values.flap = 0
		first_time = 0
	end
	if electrics.values.airspeed >= 80 then
	if electrics.values.flap == 0 then
		if M.pitch > 0.2                           then input.event('elevator', -1)
		elseif M.pitch > 0.15  and M.pitch < 0.2   then input.event('elevator', -0.35)
		elseif M.pitch > 0.05  and M.pitch < 0.15  then input.event('elevator', -0.15)
		elseif M.pitch > 0.02  and M.pitch < 0.05  then input.event('elevator', -0.05)
		elseif M.pitch > -0.02 and M.pitch < 0.02  then input.event('elevator', 0.08)
		elseif M.pitch < -0.02 and M.pitch > -0.05 then input.event('elevator', 0.15)
		elseif M.pitch < -0.05 and M.pitch > -0.15 then input.event('elevator', 0.25)
		elseif M.pitch < -0.15 and M.pitch > -0.2  then input.event('elevator', 0.35)
		elseif M.pitch < -0.2                      then input.event('elevator', 1)
		end
	else
		if M.pitch > 0.2                           then input.event('elevator', -1)
		elseif M.pitch > 0.15  and M.pitch < 0.2   then input.event('elevator', -0.35*(electrics.values.flap+1))
		elseif M.pitch > 0.05  and M.pitch < 0.15  then input.event('elevator', -0.18*(electrics.values.flap+1))
		elseif M.pitch > 0.02  and M.pitch < 0.05  then input.event('elevator', -0.1*(electrics.values.flap+1))
		elseif M.pitch > -0.02 and M.pitch < 0.02  then input.event('elevator', 0.1*(electrics.values.flap+1))
		elseif M.pitch < -0.02 and M.pitch > -0.05 then input.event('elevator', 0.15*(electrics.values.flap+1))
		elseif M.pitch < -0.05 and M.pitch > -0.15 then input.event('elevator', 0.25*(electrics.values.flap+1))
		elseif M.pitch < -0.15 and M.pitch > -0.2  then input.event('elevator', 0.35*(electrics.values.flap+1))
		elseif M.pitch < -0.2                      then input.event('elevator', 1)
		end end
	else
	if electrics.values.flap == 0 then
		if M.pitch > 0.2                           then input.event('elevator', -1)
		elseif M.pitch > 0.15  and M.pitch < 0.2   then input.event('elevator', -0.35)
		elseif M.pitch > 0.05  and M.pitch < 0.15  then input.event('elevator', -0.2)
		elseif M.pitch > 0.02  and M.pitch < 0.05  then input.event('elevator', -0.15)
		elseif M.pitch > -0.02 and M.pitch < 0.02  then input.event('elevator', 0.15)
		elseif M.pitch < -0.02 and M.pitch > -0.05 then input.event('elevator', 0.2)
		elseif M.pitch < -0.05 and M.pitch > -0.15 then input.event('elevator', 0.25)
		elseif M.pitch < -0.15 and M.pitch > -0.2  then input.event('elevator', 0.35)
		elseif M.pitch < -0.2                      then input.event('elevator', 1)
		end
	else
		if M.pitch > 0.2                           then input.event('elevator', -1)
		elseif M.pitch > 0.15  and M.pitch < 0.2   then input.event('elevator', -0.3*(electrics.values.flap+1))
		elseif M.pitch > 0.05  and M.pitch < 0.15  then input.event('elevator', -0.2*(electrics.values.flap+1))
		elseif M.pitch > 0.02  and M.pitch < 0.05  then input.event('elevator', -0.1*(electrics.values.flap+1))
		elseif M.pitch > -0.02 and M.pitch < 0.02  then input.event('elevator', 0.2*(electrics.values.flap+1))
		elseif M.pitch < -0.02 and M.pitch > -0.05 then input.event('elevator', 0.4*(electrics.values.flap+1))
		elseif M.pitch < -0.05 and M.pitch > -0.15 then input.event('elevator', 0.5*(electrics.values.flap+1))
		elseif M.pitch < -0.15 and M.pitch > -0.2  then input.event('elevator', 0.7*(electrics.values.flap+1))
		elseif M.pitch < -0.2                      then input.event('elevator', 1)
		end end end
	if M.roll > 0.2                          then input.event('aileron', 1)
	elseif M.roll > 0.15  and M.roll < 0.2   then input.event('aileron', 0.5)
	elseif M.roll > 0.05  and M.roll < 0.15  then input.event('aileron', 0.2)
	elseif M.roll > 0.01  and M.roll < 0.05  then input.event('aileron', 0.1)
	elseif M.roll > -0.01 and M.roll < 0.01  then input.event('aileron', 0)
	elseif M.roll < -0.01 and M.roll > -0.05 then input.event('aileron', -0.1)
	elseif M.roll < -0.05 and M.roll > -0.15 then input.event('aileron', -0.2)
	elseif M.roll < -0.15 and M.roll > -0.2  then input.event('aileron', -0.5)
	elseif M.roll < -0.2                     then input.event('aileron', -1)
	end	
elseif auto_pilot_mode == 4 then
if electrics.values.gear == 0 or OnGround == 0 then
	first_speed = 1
	first_time = 1
	landed = 0
	speed_controller = 1
	if first_yaw == 1 then
		current_yaw = M.yaw
		input.event('aileron', 0)
		input.event('elevator', 0)
		input.event('rudder', 0)
		current_z = M.pos.z
		first_yaw = 0
	end
	electrics.values.brake_combined = 0
	electrics.values.flap = 0
	electrics.values.jet_throttle = 1
	if OnGround == 1 then electrics.values.gear = 0 input.event('elevator', -0.15) end
	if electrics.values.airspeed > 70 then OnGround = 0 end
	if OnGround == 0 then
		electrics.values.gear = 1
			if M.pitch > 0.17 and M.pitch < 0.2 then input.event('elevator', 0.1)
			elseif M.pitch > 0.15 and M.pitch < 0.17 then input.event('elevator', 0.2)
			elseif M.pitch < 0.15 then input.event('elevator', 0.5)
			elseif M.pitch >= 0.2 then input.event('elevator', -0.05) end
		if M.pos.z > current_z + 200 then auto_pilot_mode = 1 gui.message('Plane took off. Autopilot mode automatically changed to: Maintain heading') end end
	if M.roll > 0.2                          then input.event('aileron', 1)
	elseif M.roll > 0.15  and M.roll < 0.2   then input.event('aileron', 0.5)
	elseif M.roll > 0.05  and M.roll < 0.15  then input.event('aileron', 0.25)
	elseif M.roll > 0.01  and M.roll < 0.05  then input.event('aileron', 0.15)
	elseif M.roll > -0.01 and M.roll < 0.01  then input.event('aileron', 0)
	elseif M.roll < -0.01 and M.roll > -0.05 then input.event('aileron', -0.15)
	elseif M.roll < -0.05 and M.roll > -0.15 then input.event('aileron', -0.25)
	elseif M.roll < -0.15 and M.roll > -0.2  then input.event('aileron', -0.5)
	elseif M.roll < -0.2                     then input.event('aileron', -1)
	end
	if electrics.values.gear == 0 and electrics.values.airspeed < 70 then
	if M.yaw > current_yaw+0.3                               	 then input.event('rudder', 1)
	elseif M.yaw > current_yaw+0.15 and M.yaw < current_yaw+0.3  then input.event('rudder', 0.5)
	elseif M.yaw > current_yaw+0.05 and M.yaw < current_yaw+0.15 then input.event('rudder', 0.25)
	elseif M.yaw > current_yaw+0.02	and M.yaw < current_yaw+0.05 then input.event('rudder', 0.15)
	elseif M.yaw > current_yaw-0.005 and M.yaw < current_yaw+0.02 then input.event('rudder', 0.05)
	elseif M.yaw < current_yaw-0.005	and M.yaw > current_yaw-0.05 then input.event('rudder', -0.15)
	elseif M.yaw < current_yaw-0.05 and M.yaw > current_yaw-0.15 then input.event('rudder', -0.25)
	elseif M.yaw < current_yaw-0.15 and M.yaw > current_yaw-0.3  then input.event('rudder', -0.5)
	elseif M.yaw < current_yaw-0.3                          	 then input.event('rudder', -1)
	end
	else input.event('rudder', 0) end
else gui.message("You can't change the autopilot mode to takeoff when you aren't on earth.") end
elseif auto_pilot_mode == 2 then
	first_yaw = 1
	OnGround = 1
	landed = 0
	first_time = 1
	if first_speed == 1 then
		current_speed = electrics.values.airspeed
		input.event('aileron', 0)
		input.event('elevator', 0)
		input.event('rudder', 0)
		electrics.values.flap = 0
		first_speed = 0
	end
	if electrics.values.airspeed > 55 or lowSpeedWarning == nil then
	if lowSpeedWarning ~= nil then
	obj:setVolume(lowSpeedWarning, 0)
	obj:cutSFX(lowSpeedWarning) end
	if speed_controller == 1 then
	if electrics.values.airspeed > current_speed+3   												   	   then electrics.values.jet_throttle_change = -1 electrics.values.flap = 0.5
	elseif electrics.values.airspeed > current_speed+1   and electrics.values.airspeed < current_speed+3   then electrics.values.jet_throttle_change = -0.5 electrics.values.flap = 0.35
	elseif electrics.values.airspeed > current_speed+0.2 and electrics.values.airspeed < current_speed+1   then electrics.values.jet_throttle_change = -0.35 electrics.values.flap = 0.2
	elseif electrics.values.airspeed > current_speed-0.2 and electrics.values.airspeed < current_speed+0.2 then electrics.values.jet_throttle_change = 0 electrics.values.flap = 0
	elseif electrics.values.airspeed < current_speed-0.2 and electrics.values.airspeed > current_speed-1   then electrics.values.jet_throttle_change = 0.5 electrics.values.flap = 0
	elseif electrics.values.airspeed < current_speed-1 	 and electrics.values.airspeed > current_speed-3   then electrics.values.jet_throttle_change = 1 electrics.values.flap = 0
	end end
	elseif electrics.values.gear == 1 and electrics.values.airspeed > 18 then speed_controller = 0 gui.message("You're going too slow, speed cotroller turned off. Increase the speed!") obj:setVolume(lowSpeedWarning, 7) obj:playSFX(lowSpeedWarning) end
	if electrics.values.airspeed >= 80 then
	if electrics.values.flap == 0 then
		if M.pitch > 0.2                           then input.event('elevator', -1)
		elseif M.pitch > 0.15  and M.pitch < 0.2   then input.event('elevator', -0.35)
		elseif M.pitch > 0.05  and M.pitch < 0.15  then input.event('elevator', -0.15)
		elseif M.pitch > 0.02  and M.pitch < 0.05  then input.event('elevator', -0.05)
		elseif M.pitch > -0.02 and M.pitch < 0.02  then input.event('elevator', 0.08)
		elseif M.pitch < -0.02 and M.pitch > -0.05 then input.event('elevator', 0.15)
		elseif M.pitch < -0.05 and M.pitch > -0.15 then input.event('elevator', 0.25)
		elseif M.pitch < -0.15 and M.pitch > -0.2  then input.event('elevator', 0.35)
		elseif M.pitch < -0.2                      then input.event('elevator', 1)
		end
	else
		if M.pitch > 0.2                           then input.event('elevator', -1)
		elseif M.pitch > 0.15  and M.pitch < 0.2   then input.event('elevator', -0.35*(electrics.values.flap+1))
		elseif M.pitch > 0.05  and M.pitch < 0.15  then input.event('elevator', -0.18*(electrics.values.flap+1))
		elseif M.pitch > 0.02  and M.pitch < 0.05  then input.event('elevator', -0.1*(electrics.values.flap+1))
		elseif M.pitch > -0.02 and M.pitch < 0.02  then input.event('elevator', 0.1*(electrics.values.flap+1))
		elseif M.pitch < -0.02 and M.pitch > -0.05 then input.event('elevator', 0.15*(electrics.values.flap+1))
		elseif M.pitch < -0.05 and M.pitch > -0.15 then input.event('elevator', 0.25*(electrics.values.flap+1))
		elseif M.pitch < -0.15 and M.pitch > -0.2  then input.event('elevator', 0.35*(electrics.values.flap+1))
		elseif M.pitch < -0.2                      then input.event('elevator', 1)
		end end
	else
	if electrics.values.flap == 0 then
		if M.pitch > 0.2                           then input.event('elevator', -1)
		elseif M.pitch > 0.15  and M.pitch < 0.2   then input.event('elevator', -0.35)
		elseif M.pitch > 0.05  and M.pitch < 0.15  then input.event('elevator', -0.2)
		elseif M.pitch > 0.02  and M.pitch < 0.05  then input.event('elevator', -0.15)
		elseif M.pitch > -0.02 and M.pitch < 0.02  then input.event('elevator', 0.15)
		elseif M.pitch < -0.02 and M.pitch > -0.05 then input.event('elevator', 0.2)
		elseif M.pitch < -0.05 and M.pitch > -0.15 then input.event('elevator', 0.25)
		elseif M.pitch < -0.15 and M.pitch > -0.2  then input.event('elevator', 0.35)
		elseif M.pitch < -0.2                      then input.event('elevator', 1)
		end
	else
		if M.pitch > 0.2                           then input.event('elevator', -1)
		elseif M.pitch > 0.15  and M.pitch < 0.2   then input.event('elevator', -0.3*(electrics.values.flap+1))
		elseif M.pitch > 0.05  and M.pitch < 0.15  then input.event('elevator', -0.2*(electrics.values.flap+1))
		elseif M.pitch > 0.02  and M.pitch < 0.05  then input.event('elevator', -0.1*(electrics.values.flap+1))
		elseif M.pitch > -0.02 and M.pitch < 0.02  then input.event('elevator', 0.2*(electrics.values.flap+1))
		elseif M.pitch < -0.02 and M.pitch > -0.05 then input.event('elevator', 0.4*(electrics.values.flap+1))
		elseif M.pitch < -0.05 and M.pitch > -0.15 then input.event('elevator', 0.5*(electrics.values.flap+1))
		elseif M.pitch < -0.15 and M.pitch > -0.2  then input.event('elevator', 0.7*(electrics.values.flap+1))
		elseif M.pitch < -0.2                      then input.event('elevator', 1)
		end end end
	if M.roll > 0.2                          then input.event('aileron', 1)
	elseif M.roll > 0.15  and M.roll < 0.2   then input.event('aileron', 0.5)
	elseif M.roll > 0.05  and M.roll < 0.15  then input.event('aileron', 0.2)
	elseif M.roll > 0.01  and M.roll < 0.05  then input.event('aileron', 0.1)
	elseif M.roll > -0.01 and M.roll < 0.01  then input.event('aileron', 0)
	elseif M.roll < -0.01 and M.roll > -0.05 then input.event('aileron', -0.1)
	elseif M.roll < -0.05 and M.roll > -0.15 then input.event('aileron', -0.2)
	elseif M.roll < -0.15 and M.roll > -0.2  then input.event('aileron', -0.5)
	elseif M.roll < -0.2                     then input.event('aileron', -1)
	end
elseif auto_pilot_mode == 3 then
	first_yaw = 1
	first_z = 1
	landed = 0
	OnGround = 1
	first_time = 1
	if first_speed == 1 then
		current_speed = electrics.values.airspeed
		input.event('aileron', 0)
		input.event('elevator', 0)
		input.event('rudder', 0)
		electrics.values.flap = 0
		speed_controller = 1
		first_speed = 0
	end
	if electrics.values.airspeed > 55 or lowSpeedWarning == nil then
	if lowSpeedWarning ~= nil then
	obj:setVolume(lowSpeedWarning, 0)
	obj:cutSFX(lowSpeedWarning) end
	if speed_controller == 1 then
	if electrics.values.airspeed > current_speed+3   												   	   then electrics.values.jet_throttle_change = -1 electrics.values.flap = 0.5
	elseif electrics.values.airspeed > current_speed+1   and electrics.values.airspeed < current_speed+3   then electrics.values.jet_throttle_change = -0.5 electrics.values.flap = 0.35
	elseif electrics.values.airspeed > current_speed+0.2 and electrics.values.airspeed < current_speed+1   then electrics.values.jet_throttle_change = -0.35 electrics.values.flap = 0.2
	elseif electrics.values.airspeed > current_speed-0.2 and electrics.values.airspeed < current_speed+0.2 then electrics.values.jet_throttle_change = 0 electrics.values.flap = 0
	elseif electrics.values.airspeed < current_speed-0.2 and electrics.values.airspeed > current_speed-1   then electrics.values.jet_throttle_change = 0.5 electrics.values.flap = 0
	elseif electrics.values.airspeed < current_speed-1 	 and electrics.values.airspeed > current_speed-3   then electrics.values.jet_throttle_change = 1 electrics.values.flap = 0
	end end
	elseif electrics.values.gear == 1 and electrics.values.airspeed > 18 then speed_controller = 0 gui.message("You're going too slow, speed cotroller turned off. Increase the speed!") obj:setVolume(lowSpeedWarning, 7) obj:playSFX(lowSpeedWarning) end
elseif auto_pilot_mode == 5 then
	first_yaw = 1
	first_speed = 1
	first_z = 1
	OnGround = 1
	electrics.values.gear = 0
	first_time = 1
	if electrics.values.airspeed < 0.5 and M.roll > -0.02 and M.roll < 0.02 and M.pitch > -0.02 and M.pitch < 0.02 then landed = 1 end
	if landed == 1 then	electrics.values.flap = 0 electrics.values.brake_combined = 1 gui.message("Landing completed. If you want to fly again, change the autopilot mode or deactivate it.") else electrics.values.flap = 1 gui.message("Autopilot controls the throttle, roll and flaps of the plane. You should control the pitch and brakes yourself. Hint: Try to descrease the fly height to about 10 meters, then descrease the fly height very very very slowly until the gears touch the ground, then press brake.") end
	electrics.values.jet_throttle = 0 
	if M.roll > 0.2                          then input.event('aileron', 1)
	elseif M.roll > 0.15  and M.roll < 0.2   then input.event('aileron', 0.5)
	elseif M.roll > 0.05  and M.roll < 0.15  then input.event('aileron', 0.2)
	elseif M.roll > 0.01  and M.roll < 0.05  then input.event('aileron', 0.1)
	elseif M.roll > -0.01 and M.roll < 0.01  then input.event('aileron', 0)
	elseif M.roll < -0.01 and M.roll > -0.05 then input.event('aileron', -0.1)
	elseif M.roll < -0.05 and M.roll > -0.15 then input.event('aileron', -0.2)
	elseif M.roll < -0.15 and M.roll > -0.2  then input.event('aileron', -0.5)
	elseif M.roll < -0.2                     then input.event('aileron', -1)
	end
end
else
if change_to_default == 1 then
	input.event('aileron', 0)
	input.event('elevator', 0)
	input.event('rudder', 0)
	electrics.values.flap = 0
	electrics.values.brake_combined = 0
	if lowSpeedWarning ~= nil then obj:setVolume(lowSpeedWarning, 0) obj:cutSFX(lowSpeedWarning) end
	if fallingWarning ~= nil then obj:setVolume(fallingWarning, 0) obj:cutSFX(fallingWarning) end
	change_to_default = 0
end
first_yaw = 1
first_z = 1
first_speed = 1
first_time = 1
OnGround = 1
landed = 0
speed_controller = 1
jump_to_mode1 = 0
jump_to_mode2 = 0
jump_to_mode3 = 0
jump_to_mode4 = 0
jump_to_mode5 = 0
toggle_auto_pilot_mode = 0 end
else toggle_auto_pilot = 0 toggle_auto_pilot_mode = 0 end end
M.onInit	= onInit
M.updateGFX = updateGFX

return M